Create Document note.document.add

If you are developing integrations for Bitrix24 using AI tools (Codex, Claude Code, Cursor), connect to the MCP server so that the assistant can utilize the official REST documentation.

Scope: note

Who can execute the method: a user with access to the Knowledge base module and "Edit" permissions for the required knowledge base

The note.document.add method creates a new document in the knowledge base and returns its object.

Method Parameters

Required parameters are marked with *

Name
type

Description

fields*
object

Object with the fields of the new document. Object structure description

Parameter fields

Name
type

Description

collectionId*
integer

Knowledge base identifier.

The identifier can be obtained using the note.collection.list method.

title*
string

Document title.

The document title must not exceed 255 characters.

parentId
integer

Parent document identifier.

The identifier can be obtained using the note.document.tree.list method.

Use this if you need to create a nested document. The parent document must belong to the same knowledge base as collectionId.

markdown
string

Initial document content in Markdown.

Maximum size: 1 048 576 bytes.

Code Examples

How to Use Examples in Documentation

The new API call differs by adding the /api/ segment to the request URL:

https://{installation_address}/rest/api/{user_id}/{webhook_token}/note.document.add

curl -X POST \
        -H "Content-Type: application/json" \
        -H "Accept: application/json" \
        -d '{"fields":{"collectionId":42,"title":"Chapter 1","parentId":10,"markdown":"# Chapter 1\N\nDocument Text"}}' \
        https://**put_your_bitrix24_address**/rest/api/**put_your_user_id_here**/**put_your_webhook_here**/note.document.add
        
curl -X POST \
        -H "Content-Type: application/json" \
        -H "Accept: application/json" \
        -d '{"fields":{"collectionId":42,"title":"Chapter 1","parentId":10,"markdown":"# Chapter 1\N\nDocument Text"},"auth":"**put_access_token_here**"}' \
        https://**put_your_bitrix24_address**/rest/api/note.document.add
        
import { Text } from '@bitrix24/b24jssdk'
        import type { B24Frame } from '@bitrix24/b24jssdk'
        
        declare const $b24: B24Frame
        
        type DocumentAddResult = {
          item: {
            id: number
            collectionId: number | null
            parentId: number | null
            title: string
            markdown: string
            position: number
            createdBy: number
            updatedBy: number
            createdAt: string
            updatedAt: string
          }
        }
        
        try {
          const response = await $b24.actions.v3.call.make<DocumentAddResult>({
            method: 'note.document.add',
            params: {
              fields: {
                collectionId: 42,
                title: 'Chapter 1',
                parentId: 10,
                markdown: '# Chapter 1\N\nDocument Text',
              },
            },
            requestId: Text.getUuidRfc4122()
          })
        
          if (!response.isSuccess) {
            console.error(response.getErrorMessages().join('; '))
          } else {
            const result = response.getData()!.result
            console.info('Document created:', result.item.id, result.item.title)
          }
        } catch (error) {
          console.error(error)
        }
        
<script src="https://unpkg.com/@bitrix24/b24jssdk@1/dist/umd/index.min.js"></script>
        <script>
          async function addDocument() {
            try {
              const $b24 = await B24Js.initializeB24Frame()
        
              const response = await $b24.actions.v3.call.make({
                method: 'note.document.add',
                params: {
                  fields: {
                    collectionId: 42,
                    title: 'Chapter 1',
                    parentId: 10,
                    markdown: '# Chapter 1\N\nDocument Text',
                  },
                },
                requestId: B24Js.Text.getUuidRfc4122()
              })
        
              if (!response.isSuccess) {
                console.error(response.getErrorMessages().join('; '))
                return
              }
        
              const result = response.getData().result
              console.info('Document created:', result.item.id, result.item.title)
            } catch (error) {
              console.error(error)
            }
          }
        
          document.addEventListener('DOMContentLoaded', addDocument)
        </script>
        

SDKs do not yet support the /rest/api/ address in calls. Use direct HTTP requests, for example, via curl or fetch.

try {
            $response = $b24Service
                ->core
                ->call(
                    'note.document.add',
                    [
                        'fields' => [
                            'collectionId' => 42,
                            'title' => 'Chapter 1',
                            'parentId' => 10,
                            'markdown' => "# Chapter 1\N\nDocument Text",
                        ],
                    ]
                );
        
            $result = $response
                ->getResponseData()
                ->getResult();
        
            echo 'Success: ' . print_r($result, true);
        
        } catch (Throwable $e) {
            error_log($e->getMessage());
            echo 'Error creating document: ' . $e->getMessage();
        }
        

SDKs do not yet support the /rest/api/ address in calls. Use direct HTTP requests, for example, via curl or fetch.

BX24.callMethod(
            'note.document.add',
            {
                fields: {
                    collectionId: 42,
                    title: 'Chapter 1',
                    parentId: 10,
                    markdown: '# Chapter 1\N\nDocument Text'
                }
            },
            function(result){
                console.info(result.data());
                console.log(result);
            }
        );
        

SDKs do not yet support the /rest/api/ address in calls. Use direct HTTP requests, for example, via curl or fetch.

require_once('crest.php');
        
        $result = CRest::call(
            'note.document.add',
            [
                'fields' => [
                    'collectionId' => 42,
                    'title' => 'Chapter 1',
                    'parentId' => 10,
                    'markdown' => "# Chapter 1\N\nDocument Text"
                ]
            ]
        );
        
        echo '<PRE>';
        print_r($result);
        echo '</PRE>';
        

Response Handling

HTTP status: 200

{
            "result": {
                "item": {
                    "id": 77,
                    "collectionId": 42,
                    "parentId": 10,
                    "title": "Chapter 1",
                    "markdown": "
        
        # Chapter 1\N\nText in Markdown...",
                    "position": 5,
                    "createdBy": 1,
                    "updatedBy": 1,
                    "createdAt": "2026-04-20T12:00:00Z",
                    "updatedAt": "2026-04-20T12:00:00Z"
                }
            },
            "time": {
                "start": 1780390800,
                "finish": 1780390800.214321,
                "duration": 0.21432113647460938,
                "processing": 0.17321419715881348,
                "date_start": "2026-06-16T12:00:00+03:00",
                "date_finish": "2026-06-16T12:00:00+03:00",
                "operating_reset_at": 1780391400,
                "operating": 0
            }
        }
        

Returned Data

Name
type

Description

result
object

Object with the document creation result.

item
object

Created document object.

id
integer

Identifier of the created document

collectionId
integer

Knowledge base identifier.

parentId
integer

Parent document identifier or null.

title
string

Document title.

markdown
string

Document content in Markdown.

position
integer

Document position among neighboring pages.

createdBy
integer

Identifier of the document author

updatedBy
integer

Last document editor identifier.

createdAt
datetime

Document creation date and time in UTC.

updatedAt
datetime

Document last modification date and time in UTC.

time
time

Information about the request execution time

Error Handling

HTTP status: 400

{
            "error": {
                "code": "BITRIX_REST_V3_EXCEPTION_VALIDATION_DTOVALIDATIONEXCEPTION",
                "message": "Object validation error",
                "validation": [
                    {
                        "message": "Mandatory field \"title\" is not filled",
                        "field": "title"
                    }
                ]
            }
        }
        

Name
type

Description

error.code
string

String error code. Use it to identify the type of exception

error.message
string

Text description of the error

error.validation
array

Array with error details. Present only in data validation errors BITRIX_REST_V3_EXCEPTION_VALIDATION_REQUESTVALIDATIONEXCEPTION

error.validation[].field
string

Name of the field where the validation error occurred

error.validation[].message
string

Description of the error related to the specified field

Possible Error Codes

Request Validation Errors

Error Code: BITRIX_REST_V3_EXCEPTION_VALIDATION_REQUESTVALIDATIONEXCEPTION

Field

Error description

How to Fix

fields

Required field fields is not specified.

Add the fields object to the request body.

Error Code: BITRIX_REST_V3_EXCEPTION_VALIDATION_DTOVALIDATIONEXCEPTION

Field

Error description

How to Fix

collectionId
title

Required field #FIELD# is not filled.

Add the specified field to the fields object.

collectionId
title
parentId
markdown

The field #FIELD# requires data type #TYPE# for this request.

Ensure the provided value is of the correct type

title

Document title cannot be empty.

Pass a non-empty string in the fields.title field.

title

Document title must not exceed 255 characters.

Shorten the fields.title value.

Error Code: NOTE_MARKDOWN_TOO_LARGE

Field

Error description

How to Fix

markdown

Document content is too large. The maximum allowed size is 1 048 576 bytes.

Shorten the fields.markdown content.

Error Code: NOTE_INVALID_PARENT

Field

Error description

How to Fix

parentId

The parent document does not belong to the specified collection.

Specify the fields.parentId of the document from the same knowledge base as fields.collectionId, or do not pass fields.parentId.

Access Errors

Error Code: BITRIX_REST_V3_EXCEPTION_ACCESSDENIEDEXCEPTION

Field

Error description

How to Fix

-

Access denied.

The user does not have access to the Knowledge Base module or the permissions to create documents in the specified knowledge base.

Object Not Found Error

Error Code: BITRIX_REST_V3_EXCEPTION_ENTITYNOTFOUNDEXCEPTION

Field

Error description

How to Fix

collectionId

Knowledge base not found.

Please check that the knowledge base exists and is accessible to the user.

Statuses and System Error Codes

HTTP Status: 20x, 40x, 50x

The errors described below may occur when calling any method.

Status

Code
Error Message

Description

500

INTERNAL_SERVER_ERROR
Internal server error

An internal server error has occurred. Please contact the server administrator or Bitrix24 technical support

500

ERROR_UNEXPECTED_ANSWER
Server returned an unexpected response

An internal server error has occurred. Please contact the server administrator or Bitrix24 technical support

503

QUERY_LIMIT_EXCEEDED
Too many requests

The request intensity limit has been exceeded

405

ERROR_BATCH_METHOD_NOT_ALLOWED
Method is not allowed for batch usage

The current method is not permitted for calls using batch

400

ERROR_BATCH_LENGTH_EXCEEDED
Max batch length exceeded

The maximum length of parameters passed to the batch method has been exceeded

401

NO_AUTH_FOUND
Wrong authorization data

Invalid access token or webhook code

400

INVALID_REQUEST
Https required

The HTTPS protocol is required for method calls

503

OVERLOAD_LIMIT
REST API is blocked due to overload

The REST API is blocked due to overload. This is a manual individual block; please contact Bitrix24 technical support to lift it

403

ACCESS_DENIED
REST API is available only on commercial plans

The REST API is only available on commercial plans

403

INVALID_CREDENTIALS
Invalid request credentials

The user associated with the access token or webhook used to call the method lacks the necessary permissions

404

ERROR_MANIFEST_IS_NOT_AVAILABLE
Manifest is not available

The manifest is not available

403

insufficient_scope
The request requires higher privileges than provided by the webhook token

The request requires higher privileges than those provided by the webhook token

401

expired_token
The access token provided has expired

The provided access token has expired

403

user_access_error
The user does not have access to the application

The user does not have access to the application. This means that the application is installed, but the portal administrator has restricted access to this application to specific users only

500

PORTAL_DELETED
Portal was deleted

The public part of the site is closed. To open the public part of the site on an on-premise installation, disable the "Temporary closure of the public part of the site" option. Path to the setting: Desktop > Settings > Product Settings > Module Settings > Main Module > Temporary closure of the public part of the site

Continue Learning